#!/usr/bin/perl -w
# This is used for moving from human readable life format to a code format.
# Run like life4d2java.pl < glider.4dlife
#glider.4dlife
##P -2 -2 -1 -1  Treated as a comment, program finds own center
#.**.
#*..*
#*..*
#
#....
#.**.
#.**.
#
#
#.**.
#*..*
#*..*
#
#....
#.**.
#.**.

local($PTS, $ncols, $nrows, $nstacks, $nzones);

#local($offset) = shift(@ARGV);
#if ($offset eq "") {
  $offset = 0;
#}

print "
Drop these points in Life4DForms.java array and
make up a name for name array\n\n";
#Drop these points in life.c, within the 'patterns' array.
#Note if the number of points > 48, one must increase points NUMPTS;
#also to fit most screens and especially the iconified window,
#one should have the size < 32x32.\n\n";
&search;
print "\npoints = $PTS; size = ${ncols}x${nrows}x${nstacks}x${nzones}\n";

sub search {
  local ($col, $row, $stack, $zone);
  local ($firstcol, $firstrow, $firststack, $firstzone);
  local ($i, $j, $k, $l);
  local ($tempx, $tempy, $tempz, $tempw);
  local ($foundx, $foundy, $foundz, $c, $nlc, $newline);
  local (@array);

  $col = $row = $stack = $zone = 0;
  $firstcol = $firstrow = $firststack = $firstzone = -1;
  $PTS = $ncols = $nrows = $nstacks = $nzones = 0;
  $newline = 0;
  $nlc = '0'; # carriage return or line feed, whichever is first

  #set first and n
  $row = -1;
  while (<>) {
    if (!($_ =~ /^#/)) {
      @chars = split(//);
      $col = -1;
      $row++;
      foreach $c (@chars) {
        $col++;
        if ($c =~ /[\*0OoAVJD]/) {
          $newline = 0;
          if ($col < $firstcol || $firstcol < 0) {
            $firstcol = $col;
          }
          if ($row < $firstrow || $firstrow < 0) {
            $firstrow = $row;
          }
          if ($stack < $firststack || $firststack < 0) {
            $firststack = $stack;
          }
          if ($zone < $firstzone || $firstzone < 0) {
            $firstzone = $zone;
          }
          if ($col + 1 > $ncols) {
            $ncols = $col + 1;
          }
          if ($row + 1 > $nrows) {
            $nrows = $row + 1;
          }
          if ($stack + 1 > $nstacks) {
            $nstacks = $stack + 1;
          }
          if ($zone + 1 > $nzones) {
            $nzones = $zone + 1;
          }
          $array{$col, $row, $stack, $zone} = 1;
          $PTS++;
#        } elsif ("$pl" eq "td" && $c =~ /[ ]/) {
#          $col--;
        } elsif ($c =~ /[\.]/) {
          $newline = 0;
        } elsif ($c =~ /[\r\n]/) {
          if ($nlc eq '0' || $nlc eq $c) {
            $nlc = $c;
            if ($newline >= 2) {
              if ($col == 0) {
                $zone++;
                $stack = 0;
                $row = -1;
                $newline = 0;
              }
            } else {
              $newline++;
              if ($col == 0) {
                $stack++;
                $row = -1;
              }
            }
          }
        }
      }
    }
  }
  $col = $ncols - $firstcol;
  $row = $nrows - $firstrow;
  $stack = $nstacks - $firststack;
  $zone = $nzones - $firstzone;
#  print "n: $ncols, $nrows, $nstacks, $nzones\n";
#  print "first: $firstcol, $firstrow, $firststack, $firstzone\n";
#  print "size: $col, $row, $stack, $zone\n";
  print "\t{\n        ";
  for ($l = 0; $l < $nzones; $l++) {
    $foundz = 0;
    for ($k = 0; $k < $nstacks; $k++) {
      $foundy = 0;
      for ($j = 0; $j < $nrows; $j++) {
        $foundx = 0;
        for ($i = 0; $i < $ncols; $i++) {
          if ($array{$i, $j, $k, $l}) {
            if ($foundx) {
              printf " ";
            } elsif ($foundy) {
              print "        ";
            } elsif ($foundz) {
              print "\n        ";
            }
            $foundx = 1;
            $foundy = 1;
            $foundz = 1;
            $tempx = $i - int(($col + 1) / 2) - $firstcol + 1;
            $tempy = $j - int(($row + 1) / 2);
            $tempz = $k - int(($stack + 0) / 2);
            $tempw = $l - int(($zone + 1) / 2) + $offset;
            printf "$tempx, $tempy, $tempz, $tempw,";
          }
        }
        if ($foundx) {
          print "\n";
        }
      }
    }
    if ($l != $nzones - 1) {
      if ($foundz) {
        print "\n\n        ";
      }
    }
  }
#  print "127\n\t},\n";
  print "\t},\n";
  $ncols = $col;
  $nstacks += 1;
  $nzones += 1;
}
