#!/bin/sh
HEADLESS=0
WRAPLESS=1
while getopts hw: opt > /dev/null 2>&1; do
  case "$opt" in
  h)  HEADLESS=1
      shift;;
  w)  WRAPLESS=0
      shift;;
  # handle negatives
  \?) if ! echo $1 | awk '{ exit ! /^-[0-9]+$/ }'; then
        echo >&2 "usage: $0 [-hw] [n_RULE [n_THREADS]]"
        exit
      fi
  esac
done
#shift `expr $OPTIND - 1`

#cd Projects/java/life4d
#for i in data*.life; do
#  SIZE=`ls -s $i 2> /dev/null | awk '{print $1;}'`
#  if test "$SIZE" = "0"; then
#    rm -f $i
#  fi
#done
ls -alrt data?*.life 2> /dev/null

MAX=14
THREADS=1
OFFSET=2
if test `hostname | cut -c1` = "O"; then
  THREADS=1
elif test `hostname | cut -c1` = "I"; then
  THREADS=3
  OFFSET=4
  if test `hostname | grep X 2> /dev/null`; then
    THREADS=2
    OFFSET=`expr $OFFSET + $MAX / 2`
  fi
fi
if test $# -lt 1; then
  day=`date -u +%s/86400 | bc`
  ruleIndex=`expr $day + $OFFSET`
else
  ruleIndex=$1
  if test $# -ge 2; then
    THREADS=$2
  fi
fi
if test $ruleIndex -ge 0; then
  rand=`expr $ruleIndex % $MAX`
else
  rand=$ruleIndex
fi

COUNT=40; STIRS=0
EDGE=0; UNBOUND=0; BLOB=60
FILL=33
NUMBERED=-1
COLUMNS=34

if test $rand -eq 0; then
  NEIGHBORS=24; RULE=B4/S5; LENGTH=250; PERIOD=24; WRAP=1; SEARCH=glider
elif test $rand -eq 1; then
  NEIGHBORS=24; RULE=B4/S67; LENGTH=250; PERIOD=24; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 2; then
  NEIGHBORS=24; RULE=B4/S678; LENGTH=300; PERIOD=24; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 3; then
  NEIGHBORS=-32; RULE=B58/S8; LENGTH=250; PERIOD=1; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 4; then
  NEIGHBORS=-32; RULE=B8/S58; LENGTH=250; PERIOD=24; WRAP=$WRAPLESS; SEARCH=glider
elif test $rand -eq 5; then
  NEIGHBORS=80; RULE=B9/S89; LENGTH=200; PERIOD=1; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 6; then
  NEIGHBORS=80; RULE=B_10/S89_10; LENGTH=200; PERIOD=1; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 7; then
  NEIGHBORS=80; RULE=B_10/S9_10; LENGTH=200; PERIOD=1; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 8; then
  NEIGHBORS=80; RULE=B_10/S9_10_11; LENGTH=200; PERIOD=1; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 9; then
  NEIGHBORS=80; RULE=B_10/S_11_12_13; LENGTH=200; PERIOD=2; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 10; then
  NEIGHBORS=80; RULE=B_10/S_13_14_15_16_17; LENGTH=200; PERIOD=2; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 11; then
  NEIGHBORS=80; RULE=B_11_12/S_11_12; LENGTH=200; PERIOD=2; WRAP=1; SEARCH=glider
elif test $rand -eq 12; then
  NEIGHBORS=80; RULE=B_12/S_11_12_13_14_15; LENGTH=200; PERIOD=1; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 13; then
  NEIGHBORS=80; RULE=B_12_13/S_11_12; LENGTH=200; PERIOD=1; WRAP=$WRAPLESS; SEARCH=pattern
fi

echo "$rand: ${NEIGHBORS}${RULE}"
sleep 5
RULESTRIP=`echo $RULE | sed s:/::`
for i in $(seq 1 $THREADS); do
  a=`expr 96 + $i | awk '{ printf("%c",$0); }'`
  if test "$HEADLESS" = "1"; then
    CMD="-classpath classes com/sillycycle/bagleyd/life4d/Life4D"
  else
    CMD="-jar Life4DApp.jar"
  fi
  CMD="nohup java -server $CMD\
 -neighbors=$NEIGHBORS -rule=$RULE\
 -searchCount=$COUNT -excludePeriod=$PERIOD -stirs=$STIRS -wrap=$WRAP\
 -searchLength=$LENGTH -visible=0 -${SEARCH}Search=1 -delay=0\
 -edgeDetection=$EDGE -unboundDetection=$UNBOUND -blobPercent=$BLOB\
 -fillPercent=$FILL -numberedSearch=$NUMBERED -columns=$COLUMNS\
 -windowWidth=0 -windowHeight=0 -windowX=256 -windowY=0 -wireframe=1"
  #echo $CMD
  $CMD > data${NEIGHBORS}${RULESTRIP}_${a}.life 2>&1 &
  if test "$HEADLESS" = "1"; then
    echo $!
  fi
  sleep 4
done

sleep 5
ls -alrt data?*.life
bin/lifecheck.sh
